unit RemoteUnit;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, Buttons;

type
  TRemoteForm = class(TForm)
    btnMsg1: TSpeedButton;
    btnMsg2: TSpeedButton;
    btnMsg3: TSpeedButton;
    Bevel1: TBevel;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    grpMotorA: TGroupBox;
    grpMotorB: TGroupBox;
    grpMotorC: TGroupBox;
    StaticText1: TStaticText;
    StaticText2: TStaticText;
    StaticText3: TStaticText;
    btnMotorAFwd: TSpeedButton;
    btnMotorARwd: TSpeedButton;
    btnMotorBFwd: TSpeedButton;
    btnMotorBRwd: TSpeedButton;
    btnMotorCFwd: TSpeedButton;
    btnMotorCRwd: TSpeedButton;
    Label5: TLabel;
    btnProg1: TSpeedButton;
    btnProg5: TSpeedButton;
    btnProg4: TSpeedButton;
    btnProg3: TSpeedButton;
    btnProg2: TSpeedButton;
    btnBeep: TSpeedButton;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    Panel1: TPanel;
    btnStop: TSpeedButton;
    Label11: TLabel;
    Label12: TLabel;
    Image1: TImage;
    Timer1: TTimer;
    procedure Timer1Timer(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormHide(Sender: TObject);
    procedure ButtonClicked(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  RemoteForm: TRemoteForm;

implementation

{$R *.DFM}

uses
  FakeSpirit;

procedure TRemoteForm.Timer1Timer(Sender: TObject);
var
  msg : Word;
begin
  msg := kRemoteKeysReleased;

  if btnMotorAFwd.Down then
    msg := msg or kRemoteOutAForward;
  if btnMotorARwd.Down then
    msg := msg or kRemoteOutABackward;
  if btnMotorBFwd.Down then
    msg := msg or kRemoteOutBForward;
  if btnMotorBRwd.Down then
    msg := msg or kRemoteOutBBackward;
  if btnMotorCFwd.Down then
    msg := msg or kRemoteOutCForward;
  if btnMotorCRwd.Down then
    msg := msg or kRemoteOutCBackward;

  if msg <> kRemoteKeysReleased then
  begin
    FakeRCX.SendRemote(msg);
  end;
end;

procedure TRemoteForm.FormShow(Sender: TObject);
begin
  Timer1.Enabled := True;
end;

procedure TRemoteForm.FormHide(Sender: TObject);
begin
  Timer1.Enabled := False;
end;

procedure TRemoteForm.ButtonClicked(Sender: TObject);
var
  val : integer;
begin
  val := TSpeedButton(Sender).Tag;
  case val of
    1 : FakeRCX.SendRemote(kRemotePBMessage1);
    2 : FakeRCX.SendRemote(kRemotePBMessage2);
    3 : FakeRCX.SendRemote(kRemotePBMessage3);
    4 : FakeRCX.SendRemote(kRemoteSelProgram1);
    5 : FakeRCX.SendRemote(kRemoteSelProgram2);
    6 : FakeRCX.SendRemote(kRemoteSelProgram3);
    7 : FakeRCX.SendRemote(kRemoteSelProgram4);
    8 : FakeRCX.SendRemote(kRemoteSelProgram5);
    9 : FakeRCX.SendRemote(kRemoteStopOutOff);
   10 : FakeRCX.SendRemote(kRemotePlayASound);
  end;
  FakeRCX.SendRemote(kRemoteKeysReleased);
end;

end.
