{$B-}
unit MainUnit;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Menus, ComCtrls, OleCtrls, ToolWin, Buttons, ExtCtrls,
  Editor, SynEditHighlighter, SynHighlighterNQC, SynEditPrint,
  SynEditAutoComplete, SynCompletionProposal, SynEditPlugins,
  SynMacroRecorder, ImgList, ActnList, SynHighlighterForth,
  SynHighlighterXML, SynHighlighterHtml, SynHighlighterPas,
  SynHighlighterJava, SynHighlighterCpp, SynHighlighterCss,
  SynHighlighterTclTk, SynHighlighterPython, SynHighlighterPerl,
  SynHighlighterHC11, SynHighlighterPHP, SynHighlighterVB, SynHighlighterCS,
  SynHighlighterH8;

type
  TMainForm = class(TForm)
    mnuMain: TMainMenu;
    File1: TMenuItem;
    Edit1: TMenuItem;
    mniTools: TMenuItem;
    Help1: TMenuItem;
    About1: TMenuItem;
    New1: TMenuItem;
    Open1: TMenuItem;
    Save1: TMenuItem;
    SaveAs1: TMenuItem;
    N1: TMenuItem;
    Exit1: TMenuItem;
    Compile: TMenuItem;
    mniCompileProgram: TMenuItem;
    Download1: TMenuItem;
    DirectControl1: TMenuItem;
    dlgOpen: TOpenDialog;
    dlgSave: TSaveDialog;
    N2: TMenuItem;
    Print1: TMenuItem;
    dlgPrint: TPrintDialog;
    Diagnose1: TMenuItem;
    Firmware1: TMenuItem;
    dlgOpenFirmware: TOpenDialog;
    N3: TMenuItem;
    Run1: TMenuItem;
    Stop1: TMenuItem;
    Watch1: TMenuItem;
    Clearmemory1: TMenuItem;
    Cut1: TMenuItem;
    Copy1: TMenuItem;
    Paste1: TMenuItem;
    Delete1: TMenuItem;
    SelectAll1: TMenuItem;
    N8: TMenuItem;
    Find1: TMenuItem;
    GotoLineNumber1: TMenuItem;
    Replace1: TMenuItem;
    FindNext1: TMenuItem;
    N9: TMenuItem;
    FindRCX1: TMenuItem;
    N12: TMenuItem;
    Undo1: TMenuItem;
    DownloadandRun1: TMenuItem;
    RCXPiano1: TMenuItem;
    N14: TMenuItem;
    Contents1: TMenuItem;
    HowTo1: TMenuItem;
    Preferences1: TMenuItem;
    Window1: TMenuItem;
    Arrange1: TMenuItem;
    TileHorizontal: TMenuItem;
    Cascade1: TMenuItem;
    N10: TMenuItem;
    N15: TMenuItem;
    HideErrors1: TMenuItem;
    RecentSep: TMenuItem;
    Recent1: TMenuItem;
    Recent2: TMenuItem;
    Recent3: TMenuItem;
    Recent4: TMenuItem;
    NextField1: TMenuItem;
    InsertFile1: TMenuItem;
    N11: TMenuItem;
    Close1: TMenuItem;
    CloseAll1: TMenuItem;
    SaveAll1: TMenuItem;
    TileVertical1: TMenuItem;
    ShowTemplates1: TMenuItem;
    N6: TMenuItem;
    RCXJoystick1: TMenuItem;
    ProgramNumber1: TMenuItem;
    Program11: TMenuItem;
    Program21: TMenuItem;
    Program31: TMenuItem;
    Program41: TMenuItem;
    Program51: TMenuItem;
    Index1: TMenuItem;
    Datalog1: TMenuItem;
    N7: TMenuItem;
    MemoryMap1: TMenuItem;
    TurnRCXOff1: TMenuItem;
    ShowCodeListing1: TMenuItem;
    N5: TMenuItem;
    Webpage1: TMenuItem;
    N16: TMenuItem;
    RefreshScreen1: TMenuItem;
    Translate1xto201: TMenuItem;
    N17: TMenuItem;
    SendMessage1: TMenuItem;
    Search1: TMenuItem;
    Redo1: TMenuItem;
    N13: TMenuItem;
    FindPrevious1: TMenuItem;
    SynEditPrint: TSynEditPrint;
    dlgPrinterSetup: TPrinterSetupDialog;
    PrinterSetup1: TMenuItem;
    PageSetup1: TMenuItem;
    PrintPreview1: TMenuItem;
    Positions1: TMenuItem;
    Save2: TMenuItem;
    Load1: TMenuItem;
    dlgOpenINI: TOpenDialog;
    dlgSaveINI: TSaveDialog;
    SynNQCSyn: TSynNQCSyn;
    View1: TMenuItem;
    mniStatusbar: TMenuItem;
    UnlockFirmware1: TMenuItem;
    Remote1: TMenuItem;
    barStatus: TStatusBar;
    CloseComm: TMenuItem;
    SynNQCCompProp: TSynCompletionProposal;
    mniNqcGuide: TMenuItem;
    SynAutoComp: TSynEditAutoComplete;
    SynMacroRec: TSynMacroRecorder;
    cbrTop: TControlBar;
    barSearch: TToolBar;
    barCompile: TToolBar;
    ProgramBox: TComboBox;
    barHelp: TToolBar;
    barFile: TToolBar;
    ilEnabled: TImageList;
    ilDisabled: TImageList;
    NewBtn: TToolButton;
    OpenBtn: TToolButton;
    SaveBtn: TToolButton;
    PreviewBtn: TToolButton;
    PrintBtn: TToolButton;
    FindBtn: TToolButton;
    ReplaceBtn: TToolButton;
    CompileBtn: TToolButton;
    DownloadBtn: TToolButton;
    RunBtn: TToolButton;
    StopBtn: TToolButton;
    InfoBtn: TToolButton;
    HelpBtn: TToolButton;
    cbrLeft: TControlBar;
    cbrRight: TControlBar;
    cbrBottom: TControlBar;
    tbSep1: TToolButton;
    tbSep2: TToolButton;
    mniViewToolWindows: TMenuItem;
    barEdit: TToolBar;
    btnUndo: TToolButton;
    btnRedo: TToolButton;
    tbSep3: TToolButton;
    btnCut: TToolButton;
    btnCopy: TToolButton;
    btnPaste: TToolButton;
    btnDelete: TToolButton;
    tbSep4: TToolButton;
    btnPreferences: TToolButton;
    barTools: TToolBar;
    btnDirectControl: TToolButton;
    btnDiagnostics: TToolButton;
    btnWatch: TToolButton;
    btnPiano: TToolButton;
    btnJoystick: TToolButton;
    btnRemote: TToolButton;
    tbSep5: TToolButton;
    btnSendMessage: TToolButton;
    btnDatalog: TToolButton;
    btnMemoryMap: TToolButton;
    mnuToolbars: TPopupMenu;
    mniFileToolbar: TMenuItem;
    mniSearchToolbar: TMenuItem;
    mniCompileToolbar: TMenuItem;
    mniHelpToolbar: TMenuItem;
    mniEditToolbar: TMenuItem;
    mniToolsToolbar: TMenuItem;
    tbSep6: TToolButton;
    btnFindBrick: TToolButton;
    btnCloseComm: TToolButton;
    mniCodeExplorer: TMenuItem;
    splCodeExplorer: TSplitter;
    pnlCodeExplorer: TPanel;
    mniConfigureTools: TMenuItem;
    N4: TMenuItem;
    mniMacroManager: TMenuItem;
    Toolbars1: TMenuItem;
    mniFileToolbar1: TMenuItem;
    mniSearchToolbar1: TMenuItem;
    mniCompileToolbar1: TMenuItem;
    mniHelpToolbar1: TMenuItem;
    mniEditToolbar1: TMenuItem;
    mniToolsToolbar1: TMenuItem;
    alMain: TActionList;
    actFileToolbar: TAction;
    actSearchToolbar: TAction;
    actCompileToolbar: TAction;
    actHelpToolbar: TAction;
    actEditToolbar: TAction;
    actToolsToolbar: TAction;
    N18: TMenuItem;
    mniWindowList: TMenuItem;
    SynForthSyn: TSynForthSyn;
    SynCppSyn1: TSynCppSyn;
    SynJavaSyn1: TSynJavaSyn;
    SynPasSyn1: TSynPasSyn;
    SynHTMLSyn1: TSynHTMLSyn;
    SynXMLSyn1: TSynXMLSyn;
    SynForthCompProp: TSynCompletionProposal;
    SynPerlSyn1: TSynPerlSyn;
    SynPythonSyn1: TSynPythonSyn;
    SynTclTkSyn1: TSynTclTkSyn;
    SynCssSyn1: TSynCssSyn;
    SynHC11Syn1: TSynHC11Syn;
    SynVBSyn1: TSynVBSyn;
    SynPHPSyn1: TSynPHPSyn;
    SynCSSyn1: TSynCSSyn;
    SynH8Syn: TSynH8Syn;
    SynH8CompProp: TSynCompletionProposal;
    procedure Exit1Click(Sender: TObject);
    procedure DirectControl1Click(Sender: TObject);
    procedure OpenClick(Sender: TObject);
    procedure NewClick(Sender: TObject);
    procedure Diagnose1Click(Sender: TObject);
    procedure Firmware1Click(Sender: TObject);
    procedure ProgramBoxChange(Sender: TObject);
    procedure RunClick(Sender: TObject);
    procedure StopClick(Sender: TObject);
    procedure Watch1Click(Sender: TObject);
    procedure Clearmemory1Click(Sender: TObject);
    procedure AboutClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FindRCX1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure RCXPiano1Click(Sender: TObject);
    procedure Contents1Click(Sender: TObject);
    procedure HowTo1Click(Sender: TObject);
    procedure Preferences1Click(Sender: TObject);
    procedure File1Click(Sender: TObject);
    procedure TileHorizontalClick(Sender: TObject);
    procedure Cascade1Click(Sender: TObject);
    procedure Arrange1Click(Sender: TObject);
    procedure CompileClick(Sender: TObject);
    procedure mniToolsClick(Sender: TObject);
    procedure HideErrors1Click(Sender: TObject);
    procedure RecentFileClick(Sender: TObject);
    procedure SaveAll1Click(Sender: TObject);
    procedure CloseAll1Click(Sender: TObject);
    procedure TileVertical1Click(Sender: TObject);
    procedure ShowTemplates1Click(Sender: TObject);
    procedure RCXJoystick1Click(Sender: TObject);
    procedure Program11Click(Sender: TObject);
    procedure IndexClick(Sender: TObject);
    procedure Datalog1Click(Sender: TObject);
    procedure MemoryMap1Click(Sender: TObject);
    procedure TurnRCXOff1Click(Sender: TObject);
    procedure ShowCodeListing1Click(Sender: TObject);
    procedure Webpage1Click(Sender: TObject);
    procedure SendMessage1Click(Sender: TObject);
    procedure Window1Click(Sender: TObject);
    procedure PageSetup1Click(Sender: TObject);
    procedure PrinterSetup1Click(Sender: TObject);
    procedure Load1Click(Sender: TObject);
    procedure Save2Click(Sender: TObject);
    procedure BarDockOver(Sender: TObject; Source: TDragDockObject; X,
      Y: Integer; State: TDragState; var Accept: Boolean);
    procedure View1Click(Sender: TObject);
    procedure mniStatusbarClick(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure SaveBtnClick(Sender: TObject);
    procedure PreviewBtnClick(Sender: TObject);
    procedure PrintBtnClick(Sender: TObject);
    procedure FindBtnClick(Sender: TObject);
    procedure ReplaceBtnClick(Sender: TObject);
    procedure CompileBtnClick(Sender: TObject);
    procedure DownloadBtnClick(Sender: TObject);
    procedure UnlockFirmware1Click(Sender: TObject);
    procedure Remote1Click(Sender: TObject);
    procedure CloseCommClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure mniNqcGuideClick(Sender: TObject);
    procedure cbrBottomDockDrop(Sender: TObject; Source: TDragDockObject;
      X, Y: Integer);
    procedure SynMacroRecStateChange(Sender: TObject);
    procedure mniViewToolWindowsClick(Sender: TObject);
    procedure btnUndoClick(Sender: TObject);
    procedure btnRedoClick(Sender: TObject);
    procedure btnCutClick(Sender: TObject);
    procedure btnCopyClick(Sender: TObject);
    procedure btnPasteClick(Sender: TObject);
    procedure btnDeleteClick(Sender: TObject);
    procedure btnDirectControlClick(Sender: TObject);
    procedure btnPianoClick(Sender: TObject);
    procedure btnDiagnosticsClick(Sender: TObject);
    procedure btnWatchClick(Sender: TObject);
    procedure btnJoystickClick(Sender: TObject);
    procedure btnRemoteClick(Sender: TObject);
    procedure btnSendMessageClick(Sender: TObject);
    procedure btnDatalogClick(Sender: TObject);
    procedure btnMemoryMapClick(Sender: TObject);
    procedure cbrLeftDockDrop(Sender: TObject; Source: TDragDockObject; X,
      Y: Integer);
    procedure mniCodeExplorerClick(Sender: TObject);
    procedure pnlCodeExplorerDockOver(Sender: TObject;
      Source: TDragDockObject; X, Y: Integer; State: TDragState;
      var Accept: Boolean);
    procedure pnlCodeExplorerGetSiteInfo(Sender: TObject;
      DockClient: TControl; var InfluenceRect: TRect; MousePos: TPoint;
      var CanDock: Boolean);
    procedure mniConfigureToolsClick(Sender: TObject);
    procedure mniMacroManagerClick(Sender: TObject);
    procedure actFileToolbarExecute(Sender: TObject);
    procedure actSearchToolbarExecute(Sender: TObject);
    procedure actCompileToolbarExecute(Sender: TObject);
    procedure actHelpToolbarExecute(Sender: TObject);
    procedure actEditToolbarExecute(Sender: TObject);
    procedure actToolsToolbarExecute(Sender: TObject);
    procedure alMainUpdate(Action: TBasicAction;
      var Handled: Boolean);
    procedure mniWindowListClick(Sender: TObject);
  private
    { Private declarations }
    newcount : integer;
    fMDI : Boolean;
    procedure WMClose(var Message: TWMClose); message WM_CLOSE;
    procedure WMDROPFILES(var Message: TWMDROPFILES);
       message WM_DROPFILES;
    procedure CloseAllEditors;
    procedure FixupAlignment(aControl : TControl);
    procedure LoadToolbarImages;
    function GetEditorFormCount: integer;
    function GetEditorForm(index: integer): TEditorForm;
    function DoCreateEditorForm : TEditorForm;
    procedure UpdateStatusBar;
    procedure UpdateToolsMenu;
    procedure HandleTransferClick(Sender: TObject);
    procedure UpdateTransferList(aList : TList);
    function ProcessParams(aParams: string): string;
    procedure DoSaveAll;
    function IsStandardFirmware(aFile : string) : Boolean;
  public
    { Public declarations }
    procedure ChangeActiveEditor;
    procedure ShowCodeExplorer;
    procedure HandleOpenStateChanged(Sender : TObject);
    procedure DoSaveAs(EdFrm : TEditorForm);
    procedure DoSave(EdFrm : TEditorForm);
    procedure DoPrint(EdFrm : TEditorForm);
    procedure DoPrintPreview(EdFrm : TEditorForm);
    procedure SetToolBar(bFocused, activechild:boolean);
    procedure SelectProgram(idx : integer);
    procedure StartTask(idx : integer);
    procedure ClearMemory;
    procedure DownloadFirmware;
    procedure SaveModifiedFiles;
    procedure UpdateSynComponents;
    function ActiveEditorForm : TEditorForm;
    procedure ActivateEditorForm(index : Integer);
    procedure OpenFile(aPath : string);
    procedure SaveDesktop(aFile : string);
    procedure LoadDesktop(aFile : string);
    property EditorFormCount : integer read GetEditorFormCount;
    property EditorForms[index : integer] : TEditorForm read GetEditorForm;
    property MDI : Boolean read fMDI write fMDI;
  end;

var
  MainForm: TMainForm;

implementation

{$R *.DFM}

uses ClipBrd, ShellApi, GotoLine, SearchRCX, Piano,
     About, Controller, Diagnose, Unlock, Watch,
     ExecProgram, Preferences, ConstructUnit,
     JoystickUnit, DatalogUnit, MemoryUnit, RemoteUnit,
     CodeUnit, MessageUnit, SynEdit, DPageSetup,
     DTestPrintPreview, FakeSpirit, ParamUtils, uCodeExplorer,
     Transfer, Transdlg, uMacroForm, uWindowList,
     uHighlighterProcs;

resourcestring
  sNoRCX           = 'No connection to the programmable brick. Certain options will be unavailable.';
  sNoPort          = 'no port';
  sNoRobot         = 'no robot';
  sHideCodeError   = 'Hide Code/Error Listing';
  sShowCodeError   = 'Show Code/Error Listing';
  sFirmDwnldFailed = 'Firmware download failed. Put the RCX closer and try again.';
  sWrongNum        = 'wrong download number';
  sWarnCancelFD    = 'Firmware download cancelled.';
  sBrickCommError  = 'Unable to communicate with your brick';
  sRecording       = 'Recording';
  sEnterData       = 'Enter data';
  sEnterRunParams  = 'Enter run parameters';
  SFilterAllFiles  = 'All files|*.*|';

const
  K_NQC_GUIDE = 24;
  HELP_TAB    = 15;
  K_DESKTOP_EXT = '.dsk';

var
  TogglingFormStyle : Boolean = false;

procedure SetupSpirit;
begin
  FakeRCX.RCXType   := LocalRCXType;
  FakeRCX.PortNum   := LocalPortNum;
end;

{-----------------------------------------------}
{File Menu}

procedure TMainForm.File1Click(Sender: TObject);
begin
  {Show the recent files}
  RecentSep.Visible:=false;
  Recent1.Visible:=false;
  Recent2.Visible:=false;
  Recent3.Visible:=false;
  Recent4.Visible:=false;
  if not ShowRecent then Exit;
  if RecentFiles[1] <> '' then RecentSep.Visible:=true;
  if RecentFiles[1] <> '' then
  begin
    Recent1.Visible:=true;
    Recent1.Caption:='&1 '+RecentFiles[1];
  end;
  if RecentFiles[2] <> '' then
  begin
    Recent2.Visible:=true;
    Recent2.Caption:='&2 '+RecentFiles[2];
  end;
  if RecentFiles[3] <> '' then
  begin
    Recent3.Visible:=true;
    Recent3.Caption:='&3 '+RecentFiles[3];
  end;
  if RecentFiles[4] <> '' then
  begin
    Recent4.Visible:=true;
    Recent4.Caption:='&4 '+RecentFiles[4];
  end;
end;

procedure TMainForm.NewClick(Sender: TObject);
var
  F : TEditorForm;
begin
  newcount := newcount + 1;
  F := DoCreateEditorForm;
  if Assigned(F) then
    F.NewFile(sUntitled + IntToStr(newcount));
end;

procedure TMainForm.OpenClick(Sender: TObject);
begin
  if dlgOpen.Execute then
  begin
    OpenFile(dlgOpen.FileName);
  end;
end;

procedure TMainForm.SaveAll1Click(Sender: TObject);
begin
  DoSaveAll;
end;

procedure TMainForm.CloseAll1Click(Sender: TObject);
begin
  CloseAllEditors;
end;

procedure TMainForm.RecentFileClick(Sender: TObject);
var
  F : TEditorForm;
begin
  F := DoCreateEditorForm;
  if Assigned(F) then
    F.OpenFile(RecentFiles[TMenuItem(Sender).Tag]);
end;


procedure TMainForm.Exit1Click(Sender: TObject);
begin
  Close();
end;

{-----------------------------------------------}
{Edit Menu}

procedure TMainForm.ShowTemplates1Click(Sender: TObject);
begin
  ShowTemplates1.Checked := not ShowTemplates1.Checked;
  ShowTemplateForm := ShowTemplates1.Checked;
  ConstructForm.Visible := ShowTemplateForm;
end;

procedure TMainForm.Preferences1Click(Sender: TObject);
var
  i : integer;
begin
  if PrefForm.ShowModal = mrOK then
  begin
    // fill locked program array
    FillLockedProgramArray;
    // make sure our Fake Spirit has the correct RCXType and COMPort
    SetupSpirit;
    {HANDLE THE CHANGES}
    ConstructForm.Visible := ShowTemplateForm;
    ConstructForm.ConstructMenu.AutoPopup := ShowTemplatePopup;

    for i:=0 to EditorFormCount-1 do
    begin
      if EditorForms[i] = ActiveEditorForm then continue;
      EditorForms[i].SetValuesFromPreferences;
    end;
    if ActiveEditorForm <> nil then
      ActiveEditorForm.SetValuesFromPreferences;

    if ColorCodingChanged then
    begin
      for i:=0 to EditorFormCount-1 do
      begin
        if EditorForms[i] = ActiveEditorForm then continue;
        TEditorForm(EditorForms[i]).SetSyntaxHighlighter;
      end;
      if ActiveEditorForm <> nil then
        ActiveEditorForm.SetSyntaxHighlighter;
    end;

    if TemplatesChanged then
    begin
      ConstructForm.CreateConstructPanel;
      ConstructForm.CreateConstructPopUp;
    end;

    // copy over Code Templates
    UpdateSynComponents;

    SetToolbar(True, ActiveEditorForm <> nil);
  end;
end;

{-----------------------------------------------}
{Compile Menu}

procedure TMainForm.CompileClick(Sender: TObject);
var
  BrickAlive : boolean;
begin
  BrickAlive             := FakeRCX.IsOpen;
  Stop1.Enabled          := BrickAlive;
  Run1.Enabled           := BrickAlive;
  ProgramNumber1.Enabled := BrickAlive and IsRCX;
end;

procedure RestoreMainForm;
begin
//  if MainForm.ActiveEditorForm <> nil then
//    MainForm.ActiveEditorForm.TheEditor.Repaint;   {Seems to be sometimes necessary???}
  MainForm.SetFocus;
  MainForm.BringToFront;
end;

procedure TMainForm.Program11Click(Sender: TObject);
begin
  if not Assigned(Sender) then Exit;
  if not CheckAlive then Exit;
  TMenuItem(Sender).Checked := true;
  SelectProgram(TMenuItem(Sender).Tag);
  ProgramBox.ItemIndex := TMenuItem(Sender).Tag;
  CurrentProgramSlot := ProgramBox.ItemIndex;
end;

procedure TMainForm.ShowCodeListing1Click(Sender: TObject);
begin
  CodeForm.Visible := not CodeForm.Visible;
end;

procedure TMainForm.HideErrors1Click(Sender: TObject);
begin
  if ActiveEditorForm <> nil then
  begin
    ActiveEditorForm.TheErrors.Items.Clear;
    barStatus.Panels[1].Text := '';
    ActiveEditorForm.TheErrors.Visible := False;
    ActiveEditorForm.splErrors.Visible := False;
  end;
end;

procedure TMainForm.RunClick(Sender: TObject);
begin
  if IsRCX then
  begin
    SelectProgram(ProgramBox.ItemIndex);
  end;
  StartTask(0);
end;

procedure TMainForm.StopClick(Sender: TObject);
begin
  FakeRCX.StopAllTasks;
  FakeRCX.MotorsOff(7); // 7 == 111 binary == all 3 motors
end;

{-----------------------------------------------}
{Tools Menu}

procedure TMainForm.mniToolsClick(Sender: TObject);
var
  BrickAlive : boolean;
begin
  BrickAlive := FakeRCX.IsOpen;
  
  DirectControl1.Checked := DirectForm.Visible;
  DirectControl1.Enabled := BrickAlive;

  SendMessage1.Checked := MessageForm.Visible;
  SendMessage1.Enabled := BrickAlive and (IsRcx or IsScout);

  Diagnose1.Checked := DiagForm.Visible;
  Diagnose1.Enabled := BrickAlive;

  Watch1.Checked := WatchForm.Visible;
  Watch1.Enabled := BrickAlive;

  RCXPiano1.Checked := PianoForm.Visible;
  RCXPiano1.Enabled := true;

  RCXJoystick1.Checked := JoystickForm.Visible;
  RCXJoystick1.Enabled := BrickAlive;

  Datalog1.Checked := DatalogForm.Visible;
  Datalog1.Enabled := BrickAlive and IsRCX;

  MemoryMap1.Checked := MemoryForm.Visible;
  MemoryMap1.Enabled := BrickAlive;

  Remote1.Checked    := RemoteForm.Visible;
  Remote1.Enabled    := BrickAlive and (IsRCX or IsScout);

  ClearMemory1.Enabled := BrickAlive;

  FindRCX1.Enabled    := not BrickAlive;
  TurnRCXOff1.Enabled := BrickAlive;

  Firmware1.Enabled := IsRCX and BrickAlive;

  UnlockFirmware1.Enabled := IsRCX and BrickAlive;

  CloseComm.Enabled := BrickAlive;
end;

procedure TMainForm.DirectControl1Click(Sender: TObject);
begin
  DirectForm.Visible := not DirectForm.Visible;
end;

procedure TMainForm.Diagnose1Click(Sender: TObject);
begin
  DiagForm.Visible := not DiagForm.Visible;
end;

procedure TMainForm.Watch1Click(Sender: TObject);
begin
  WatchForm.Visible := not WatchForm.Visible;
end;

procedure TMainForm.RCXPiano1Click(Sender: TObject);
begin
  PianoForm.Visible := not PianoForm.Visible;
end;

procedure TMainForm.RCXJoystick1Click(Sender: TObject);
begin
  JoystickForm.Visible := not JoystickForm.Visible;
end;

procedure TMainForm.SendMessage1Click(Sender: TObject);
begin
  MessageForm.Visible := not MessageForm.Visible;
end;

procedure TMainForm.Datalog1Click(Sender: TObject);
begin
  DatalogForm.Visible := not DatalogForm.Visible;
end;

procedure TMainForm.MemoryMap1Click(Sender: TObject);
begin
  MemoryForm.Visible := not MemoryForm.Visible;
end;

procedure TMainForm.Clearmemory1Click(Sender: TObject);
begin
  if CheckAlive then
    ClearMemory;
end;

procedure FindRCX(atstartup:boolean);
begin
  SearchForRCX(atstartup);
  // make sure our Fake Spirit has the correct RCXType and COMPort
  SetupSpirit;
  {Change setting and give warnings based on the outcome}
  MainForm.barStatus.Panels[2].Text := FakeRCX.NicePortName;
  if not IRExists then
  begin
    if LocalStartupAction <> SU_NOCONNECT then
      MessageDlg(sNoRCX,mtInformation,[mbOK], 0);
    MainForm.barStatus.Panels[2].Text := sNoPort;
    MainForm.barStatus.Panels[3].Text := '';
    // make sure the port is not held open here
    FakeRCX.Close;
  end
  else if not FakeRCX.BrickAlive then
  begin
    if LocalStartupAction <> SU_NOCONNECT then
      MessageDlg(sNoRCX,mtInformation,[mbOK], 0);
    MainForm.barStatus.Panels[3].Text := sNoRobot;
    // make sure the port is not held open here
    FakeRCX.Close;
  end
  else if not IsRCX then
  begin
    MainForm.UnlockFirmware1Click(nil);
    if LocalRCXType = SU_SCOUT then
    begin
      MainForm.barStatus.Panels[3].Text := K_SCOUT;
    end
    else
    begin
      MainForm.barStatus.Panels[3].Text := K_CYBER;
    end;
  end
  else
  begin
    if LocalRCXType = SU_RCX2 then
      MainForm.barStatus.Panels[3].Text := K_RCX2
    else
      MainForm.barStatus.Panels[3].Text := K_RCX;
    MainForm.SelectProgram(0);
    MainForm.ProgramBox.ItemIndex := 0;
  end;
end;

procedure TMainForm.FindRCX1Click(Sender: TObject);
var
  oldCursor : TCursor;
begin
  oldCursor := Screen.Cursor;
  try
    Screen.Cursor := crHourGlass;
    FindRCX(false);
  finally
    Screen.Cursor := oldCursor;
  end;
  SetToolbar(True, ActiveEditorForm <> nil);
end;

procedure TMainForm.TurnRCXOff1Click(Sender: TObject);
begin
  if FakeRCX.Shutdown then
  begin
    SetToolbar(True, ActiveEditorForm <> nil);
  end;
end;

procedure TMainForm.Firmware1Click(Sender: TObject);
begin
  if not CheckAlive then Exit;
  if dlgOpenFirmware.Execute then
  begin
    DirectForm.Close;
    WatchForm.Close;
    DiagForm.Close;
    JoystickForm.Close;
    PianoForm.Close;
    DatalogForm.Close;
    MemoryForm.Close;
    DownloadFirmware;
  end;
end;

{-----------------------------------------------}
{Window Menu}

procedure TMainForm.TileHorizontalClick(Sender: TObject);
begin
  TileMode := tbHorizontal;
  Tile;
end;

procedure TMainForm.TileVertical1Click(Sender: TObject);
begin
  TileMode := tbVertical;
  Tile;
end;

procedure TMainForm.Cascade1Click(Sender: TObject);
begin
 Cascade;
end;

procedure TMainForm.Arrange1Click(Sender: TObject);
begin
  ArrangeIcons;
end;


{-----------------------------------------------}
{Help Menu}

procedure TMainForm.Contents1Click(Sender: TObject);
begin
  Application.HelpCommand(HELP_TAB, -3);
end;

procedure TMainForm.IndexClick(Sender: TObject);
var
  str : PChar;
begin
  str := '';
  if ActiveEditorForm <> nil then
  begin
    with ActiveEditorForm.TheEditor do
    begin
      str := PChar(GetWordAtRowCol(CaretXY));
    end;
  end;
  Application.HelpCommand(HELP_KEY, Integer(str));
end;

procedure TMainForm.HowTo1Click(Sender: TObject);
begin
  Application.HelpCommand(HELP_HELPONHELP, 0);
end;

procedure TMainForm.Webpage1Click(Sender: TObject);
const
  K_WEBPAGE = 'http://members.aol.com/johnbinder/bricxcc.htm';
//  K_WEBPAGE = 'http://www.cs.uu.nl/people/markov/lego/';
begin
  ShellExecute(Handle, 'open', K_WEBPAGE, '', '', SW_NORMAL);
end;

procedure TMainForm.AboutClick(Sender: TObject);
begin
  with TAboutBox.Create(nil) do
  try
    ShowModal();
  finally
    Free;
  end;
end;

{-----------------------------------------------}
{Toolbar}

procedure TMainForm.ProgramBoxChange(Sender: TObject);
var
  i : integer;
begin
  if not Assigned(Sender) then Exit;
  i := TComboBox(Sender).ItemIndex;
  if not CheckAlive then Exit;
  SelectProgram(i);
  case i of
    0: Program11.Checked := true;
    1: Program21.Checked := true;
    2: Program31.Checked := true;
    3: Program41.Checked := true;
    4: Program51.Checked := true;
  end;
  CurrentProgramSlot := i;
end;

{-----------------------------------------------}
{Form Creation}

procedure TMainForm.FormCreate(Sender: TObject);
begin
  FakeRCX.RxTimeout := PingTimeout;
  AppIsClosing := False;
//  FakeRCX.OnOpenStateChanged := HandleOpenStateChanged;
  fMDI := FormStyle = fsMDIForm;
  newcount := 0;
  ProgramBox.ItemIndex := 0;
  {Let Windows know we accept dropped files}
  DragAcceptFiles(Handle,true);
  // set help file
  Application.HelpFile := ProgramDir + 'Help\BricxCC.HLP';
  cbrLeft.Width := 0;
  cbrBottom.Height := 0;
  cbrRight.Width := 0;
  // initialize the highlighter data
  GetHighlighters(Self, Highlighters, False);
  dlgOpen.Filter := GetHighlightersFilter(Highlighters) + SFilterAllFiles;
  dlgSave.Filter := dlgOpen.Filter;
  dlgOpen.FilterIndex := Highlighters.IndexOf('NQC')+1;
  dlgSave.FilterIndex := dlgOpen.FilterIndex;
  SynForthCompProp.EndOfTokenChr := '';
  SynH8CompProp.EndOfTokenChr := '';
end;

procedure TMainForm.FormShow(Sender: TObject);
var
  i:integer;
  aParam : string;
  F : TEditorForm;
begin
  {Find the RCX}
  if not (TogglingFormStyle or RunningAsCOMServer) then
    FindRCX(true);
  {Show statusbar}
  barStatus.Visible  := ShowStatusbar;
  SetToolBar(true, false);
  {Open argument file, if any }
  for i := 1 to ParamCount do
  begin
    aParam := ParamStr(i);
    if (Pos('/', aParam) = 1) or (Pos('-', aParam) = 1) then
      continue; // a switch - not a file
    F := DoCreateEditorForm;
    if Assigned(F) then
      F.OpenFile(ParamStr(i));
  end;
  // process shell New and Print switches
  if ParamSwitch('/New') then
    NewClick(Self);
  if ParamSwitch('/Print') then begin
    PrintBtnClick(Self);
    // form flashes briefly then closes.  Good enough for now
    Close;
  end;
  {Add the Constructs}
  ConstructForm.CreateConstructPanel;
  if ShowTemplateForm then
    ConstructForm.Show;
  ConstructForm.CreateConstructPopup;
  ConstructForm.ConstructMenu.AutoPopup := ShowTemplatePopup;
  LoadToolbarImages;
  RestoreToolbars;
  WindowState := TWindowState(MainWindowState);
  TogglingFormStyle := False;
  ShowCodeExplorer;
  if not CodeExplorerSettings.AutoShowExplorer then
    frmCodeExplorer.Close;
  UpdateToolsMenu;
  // hook macro manager
  frmMacroManager.MacroLibrary.MacroRecorder := SynMacroRec;
  if not (TogglingFormStyle or RunningAsCOMServer) and
     FileExists(DefaultMacroLibrary) then
    frmMacroManager.CurrentLibraryPath := DefaultMacroLibrary;
end;

{Reacting on dropping a file on the form}
procedure TMainForm.WMDROPFILES(var Message: TWMDROPFILES);
var
  buffer:array[0..255] of char;
  F : TEditorForm;
  cnt, i : Integer;
begin
  cnt := DragQueryFile(Message.Drop, $FFFFFFFF, @buffer, sizeof(buffer));
  for i := 0 to cnt - 1 do
  begin
    DragQueryFile(Message.Drop,i,@buffer,sizeof(buffer));
    F := DoCreateEditorForm;
    if Assigned(F) then
      F.OpenFile(buffer);
  end;
end;

{Sets the toolbar correctly}
procedure TMainForm.SetToolBar(bFocused, activechild:boolean);
var
  E : TEditorForm;
  BrickAlive : boolean;
begin
  BrickAlive := FakeRCX.IsOpen;
  if not activechild then
  begin
    SaveBtn.Enabled := false;
    PrintBtn.Enabled := false;
    PreviewBtn.Enabled := false;
    FindBtn.Enabled := false;
    ReplaceBtn.Enabled := false;
    CompileBtn.Enabled := false;
    DownloadBtn.Enabled := false;
    btnUndo.Enabled     := False;
    btnRedo.Enabled     := False;
    btnCut.Enabled      := False;
    btnCopy.Enabled     := False;
    btnPaste.Enabled    := False;
    btnDelete.Enabled   := False;
  end else begin
    E := ActiveEditorForm;
    SaveBtn.Enabled := Assigned(E) and E.TheEditor.Modified;
    PrintBtn.Enabled := true;
    PreviewBtn.Enabled := true;
    FindBtn.Enabled := Assigned(E) and E.CanFind;
    ReplaceBtn.Enabled := Assigned(E) and E.CanReplace;
    CompileBtn.Enabled := true;
    DownloadBtn.Enabled := BrickAlive;
    btnUndo.Enabled     := Assigned(E) and E.CanUndo;
    btnRedo.Enabled     := Assigned(E) and E.CanRedo;
    btnCut.Enabled      := Assigned(E) and E.Selected and not E.TheEditor.ReadOnly;
    btnCopy.Enabled     := Assigned(E) and E.Selected;
    btnPaste.Enabled    := Assigned(E) and E.TheEditor.CanPaste;
    btnDelete.Enabled   := btnCut.Enabled;
  end;
  ProgramBox.Enabled := BrickAlive and IsRCX;
  RunBtn.Enabled     := BrickAlive;
  StopBtn.Enabled    := BrickAlive;

  btnDirectControl.Enabled := BrickAlive;
  btnSendMessage.Enabled   := BrickAlive and (IsRcx or IsScout);
  btnDiagnostics.Enabled   := BrickAlive;
  btnWatch.Enabled         := BrickAlive;
  btnPiano.Enabled         := true;
  btnJoystick.Enabled      := BrickAlive;
  btnDatalog.Enabled       := BrickAlive and IsRCX;
  btnMemoryMap.Enabled     := BrickAlive;
  btnRemote.Enabled        := BrickAlive and (IsRCX or IsScout);
  btnFindBrick.Enabled     := not BrickAlive;
  btnCloseComm.Enabled     := BrickAlive;
end;

procedure TMainForm.SelectProgram(idx : integer);
begin
  FakeRCX.SelectProgram(idx+1);
end;

procedure TMainForm.StartTask(idx : integer);
begin
  FakeRCX.StartTask(idx);
end;

procedure TMainForm.Window1Click(Sender: TObject);
var
  bEnabled : boolean;
begin
// set enabled state of menu items
  bEnabled := ActiveEditorForm <> nil;
  TileHorizontal.Enabled := bEnabled;
  TileVertical1.Enabled := bEnabled;
  Cascade1.Enabled := bEnabled;
  Arrange1.Enabled := bEnabled;
end;

procedure TMainForm.ClearMemory;
begin
  FakeRCX.ClearMemory;
  // Set program number back
  ProgramBoxChange(ProgramBox);
end;

procedure TMainForm.DownloadFirmware;
var
  val : integer;
  bUnlock : Boolean;
begin
  bUnlock := IsStandardFirmware(dlgOpenFirmware.FileName);
  val := TUnlockForm.DownloadFirmware(dlgOpenFirmware.FileName, FirmwareFast, bUnlock);
  if val = mrCancel then
    MessageDlg(sWarnCancelFD, mtWarning,[mbOK],0)
  else if val = mrNo then
    MessageDlg(sFirmDwnldFailed, mtError,[mbOK],0);
end;

procedure TMainForm.PageSetup1Click(Sender: TObject);
begin
  with TPageSetupDlg.Create(nil) do
  try
    SetValues(SynEditPrint);
    if ShowModal = mrOK then
      GetValues(SynEditPrint);
  finally
    Free;
  end;
end;

procedure TMainForm.PrinterSetup1Click(Sender: TObject);
begin
  dlgPrinterSetup.Execute;
end;

procedure TMainForm.Load1Click(Sender: TObject);
begin
  if dlgOpenINI.Execute then
  begin
    LoadWindowValuesFromFile(dlgOpenINI.FileName);
  end;
end;

procedure TMainForm.Save2Click(Sender: TObject);
begin
  if dlgSaveINI.Execute then
  begin
    SaveWindowValuesToFile(dlgSaveINI.FileName);
  end;
end;

procedure TMainForm.SaveModifiedFiles;
var
  i : integer;
  EdFrm : TEditorForm;
begin
  for i := 0 to EditorFormCount - 1 do
  begin
    EdFrm := TEditorForm(EditorForms[i]);
    if EdFrm.TheEditor.Modified then
    begin
      if EdFrm.IsNew then
      begin
        DoSaveAs(EdFrm);
      end
      else
        EdFrm.SaveFile;
    end;
  end;
end;

procedure TMainForm.BarDockOver(Sender: TObject;
  Source: TDragDockObject; X, Y: Integer; State: TDragState;
  var Accept: Boolean);
begin
  Accept := Source.Control is TToolBar;
end;

procedure TMainForm.View1Click(Sender: TObject);
begin
  ShowTemplates1.Checked := ConstructForm.Visible;
  mniStatusbar.Checked := barStatus.Visible;
  if CodeForm.Visible then
    ShowCodeListing1.Caption := sHideCodeError
  else
    ShowCodeListing1.Caption := sShowCodeError;

  HideErrors1.Enabled := (ActiveEditorForm <> nil) and
                         ActiveEditorForm.TheErrors.Visible;
end;

procedure TMainForm.mniStatusbarClick(Sender: TObject);
begin
  mniStatusbar.Checked := not mniStatusbar.Checked;
  ShowStatusbar := mniStatusbar.Checked;
  barStatus.Visible := ShowStatusbar;
  FixupAlignment(cbrBottom);
end;

procedure TMainForm.FormDestroy(Sender: TObject);
begin
  FakeRCX.OnOpenStateChanged := nil;
  MainForm := nil;
end;

procedure TMainForm.DoSaveAs(EdFrm: TEditorForm);
begin
  dlgSave.FileName := EdFrm.FileName;
  if dlgSave.Execute then
  begin
    EdFrm.SaveFileAs(dlgSave.FileName);
    AddRecentFile(dlgSave.FileName);
  end;
end;

procedure TMainForm.DoSave(EdFrm: TEditorForm);
begin
  if not Assigned(EdFrm) then Exit;
  if EdFrm.IsNew then
    DoSaveAs(EdFrm)
  else
    EdFrm.SaveFile;
end;

procedure TMainForm.DoPrint(EdFrm: TEditorForm);
begin
  if dlgPrint.Execute then
  begin
    SynEditPrint.SynEdit := EdFrm.TheEditor;
    SynEditPrint.Title   := EdFrm.Caption;
    SynEditPrint.Print;
  end;
end;

procedure TMainForm.DoPrintPreview(EdFrm: TEditorForm);
begin
  SynEditPrint.SynEdit := EdFrm.TheEditor;
  SynEditPrint.Title := EdFrm.Caption;
  with TTestPrintPreviewDlg.Create(nil) do
  try
    SynEditPrintPreview.SynEditPrint := SynEditPrint;
    ShowModal;
  finally
    Free;
  end;
end;

procedure TMainForm.SaveBtnClick(Sender: TObject);
begin
  DoSave(ActiveEditorForm);
end;

procedure TMainForm.PreviewBtnClick(Sender: TObject);
begin
  if ActiveEditorForm <> nil then
    DoPrintPreview(ActiveEditorForm);
end;

procedure TMainForm.PrintBtnClick(Sender: TObject);
begin
  if ActiveEditorForm <> nil then
    DoPrint(ActiveEditorForm);
end;

procedure TMainForm.FindBtnClick(Sender: TObject);
begin
  if ActiveEditorForm <> nil then
    ActiveEditorForm.Find1Click(Sender);
end;

procedure TMainForm.ReplaceBtnClick(Sender: TObject);
begin
  if ActiveEditorForm <> nil then
    ActiveEditorForm.Replace1Click(Sender);
end;

procedure TMainForm.CompileBtnClick(Sender: TObject);
begin
  if ActiveEditorForm <> nil then
    ActiveEditorForm.mniCompileProgramClick(Sender);
end;

procedure TMainForm.DownloadBtnClick(Sender: TObject);
begin
  if ActiveEditorForm <> nil then
    ActiveEditorForm.Download1Click(Sender);
end;

procedure TMainForm.UnlockFirmware1Click(Sender: TObject);
begin
  if not FakeRCX.PrepareBrick then
  begin
    MessageDlg(sBrickCommError, mtError, [mbOK], 0);
  end;
end;

procedure TMainForm.Remote1Click(Sender: TObject);
begin
  RemoteForm.Visible := not TMenuItem(Sender).Checked;
end;

procedure TMainForm.CloseCommClick(Sender: TObject);
begin
  if FakeRCX.Close then
  begin
    SetToolbar(True, ActiveEditorForm <> nil);
  end;
end;

procedure TMainForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  // 9/13/2002 - JCH added code here to fix an Access Violation that would
  // occur if you closed the main window with an Editor window open.
  CloseAllEditors;
  SaveToolbars;
  MainWindowState := Integer(WindowState);
  WindowState := wsNormal;
end;

procedure TMainForm.CloseAllEditors;
var i:integer;
begin
  for i := 0 to EditorFormCount - 1 do
  begin
    TEditorForm(EditorForms[i]).Close;
  end;
end;

procedure TMainForm.UpdateSynComponents;
var
  tmpSL : TStringList;
begin
  // load syntax completion proposal component
  tmpSL := TStringList.Create;
  try
    tmpSL.AddStrings(SynNQCSyn.Commands);
    tmpSL.AddStrings(SynNQCSyn.Constants);
    tmpSL.AddStrings(SynNQCSyn.Keywords);
    tmpSL.Sort;
    SynNQCCompProp.ItemList.Assign(tmpSL);
  finally
    tmpSL.Free;
  end;
  SynAutoComp.AutoCompleteList.Assign(PrefForm.CodeTemplates);
end;

procedure TMainForm.mniNqcGuideClick(Sender: TObject);
begin
  Application.HelpCommand(HELP_CONTEXT, K_NQC_GUIDE);
end;

procedure TMainForm.cbrBottomDockDrop(Sender: TObject;
  Source: TDragDockObject; X, Y: Integer);
begin
  FixupAlignment(cbrBottom);
end;

procedure TMainForm.SynMacroRecStateChange(Sender: TObject);
begin
  case SynMacroRec.State of
    msRecording :
      barStatus.Panels[1].Text := sRecording;
  else
    barStatus.Panels[1].Text := '';
  end;
end;

procedure TMainForm.mniViewToolWindowsClick(Sender: TObject);
var
  i : integer;
  F : TForm;
begin
  for i := 0 to Application.ComponentCount - 1 do
  begin
    if Application.Components[i] is TForm then
    begin
      F := TForm(Application.Components[i]);
      if F.Visible and (F <> Self) and
         (F.BorderStyle in [bsSizeToolWin, bsToolWindow]) then
        F.BringToFront;
    end;
  end;
end;

procedure TMainForm.FixupAlignment(aControl: TControl);
var
  oldAlign : TAlign;
begin
  oldAlign := aControl.Align;
  try
    aControl.Left := Width div 2;
    aControl.Top  := Height div 2;
    aControl.Align := alNone;
  finally
    aControl.Align := oldAlign;
  end;
end;

procedure TMainForm.btnUndoClick(Sender: TObject);
begin
  if ActiveEditorForm <> nil then
    ActiveEditorForm.Undo1Click(Sender);
end;

procedure TMainForm.btnRedoClick(Sender: TObject);
begin
  if ActiveEditorForm <> nil then
    ActiveEditorForm.Redo1Click(Sender);
end;

procedure TMainForm.btnCutClick(Sender: TObject);
begin
  if ActiveEditorForm <> nil then
    ActiveEditorForm.Cut1Click(Sender);
end;

procedure TMainForm.btnCopyClick(Sender: TObject);
begin
  if ActiveEditorForm <> nil then
    ActiveEditorForm.Copy1Click(Sender);
end;

procedure TMainForm.btnPasteClick(Sender: TObject);
begin
  if ActiveEditorForm <> nil then
    ActiveEditorForm.Paste1Click(Sender);
end;

procedure TMainForm.btnDeleteClick(Sender: TObject);
begin
  if ActiveEditorForm <> nil then
    ActiveEditorForm.Delete1Click(Sender);
end;

procedure TMainForm.btnDirectControlClick(Sender: TObject);
begin
  DirectForm.Show;
end;

procedure TMainForm.btnPianoClick(Sender: TObject);
begin
  PianoForm.Show;
end;

procedure TMainForm.btnDiagnosticsClick(Sender: TObject);
begin
  DiagForm.Show;
end;

procedure TMainForm.btnWatchClick(Sender: TObject);
begin
  WatchForm.Show;
end;

procedure TMainForm.btnJoystickClick(Sender: TObject);
begin
  JoystickForm.Show;
end;

procedure TMainForm.btnRemoteClick(Sender: TObject);
begin
  RemoteForm.Show;
end;

procedure TMainForm.btnSendMessageClick(Sender: TObject);
begin
  MessageForm.Show;
end;

procedure TMainForm.btnDatalogClick(Sender: TObject);
begin
  DatalogForm.Show;
end;

procedure TMainForm.btnMemoryMapClick(Sender: TObject);
begin
  MemoryForm.Show;
end;

procedure TMainForm.LoadToolbarImages;
var
  B : TBitmap;
  procedure GetResource(sName : String);
  var
    RS : TResourceStream;
  begin
    RS := TResourceStream.Create(HInstance, sName, MakeIntResource(23));
    try
      B.LoadFromStream(RS);
    finally
      RS.Free;
    end;
  end;
begin
  // load toolbar image from resource
  B := TBitmap.Create;
  try
    GetResource('TOOLBARBACKGROUND');
    cbrTop.Picture.Assign(B);
    cbrLeft.Picture.Assign(B);
    cbrRight.Picture.Assign(B);
    cbrBottom.Picture.Assign(B);

    GetResource('TOOLBARIMAGES');
    ilEnabled.AddMasked(B, clFuchsia);

    GetResource('TOOLBARIMAGES_D');
    ilDisabled.AddMasked(B, clFuchsia);
  finally
    B.Free;
  end;
end;

function TMainForm.ActiveEditorForm: TEditorForm;
begin
  Result := nil;
  if MDI then begin
    if Assigned(ActiveMDIChild) then
      Result := TEditorForm(ActiveMDIChild);
  end;
end;

function TMainForm.GetEditorFormCount: integer;
begin
  result := MDIChildCount;
end;

function TMainForm.GetEditorForm(index: integer): TEditorForm;
begin
  result := TEditorForm(MDIChildren[index]);
end;

function TMainForm.DoCreateEditorForm: TEditorForm;
begin
  Result := nil;
  if MDI then
  begin
    Result := TEditorForm.Create(Self);
    Result.Visible := True;
  end;
end;

procedure TMainForm.HandleOpenStateChanged(Sender: TObject);
begin
  if Assigned(MainForm) then
  begin
    SetToolBar(true, ActiveEditorForm <> nil);
    UpdateStatusBar;
  end;
end;

procedure TMainForm.ActivateEditorForm(index: Integer);
var
  F : TEditorForm;
begin
  if MDI then begin
    F := EditorForms[index];
    if F.WindowState = wsMinimized then
      F.WindowState := wsNormal;
    F.Show;
  end;
end;

procedure TMainForm.OpenFile(aPath: string);
var
  F : TEditorForm;
begin
  F := DoCreateEditorForm;
  if Assigned(F) then
    F.OpenFile(aPath);
  AddRecentFile(aPath);
end;

procedure TMainForm.UpdateStatusBar;
begin
  if FakeRCX.PortNum <> 0 then
    barStatus.Panels[2].Text := FakeRCX.NicePortName
  else
    barStatus.Panels[2].Text := sNoPort;

  barStatus.Panels[3].Text := '';
  if FakeRCX.RCXType = SU_SCOUT then
    barStatus.Panels[3].Text := K_SCOUT
  else if FakeRCX.RCXType = SU_CYBERMASTER then
    barStatus.Panels[3].Text := K_CYBER
  else if FakeRCX.RCXType = SU_RCX2 then
    barStatus.Panels[3].Text := K_RCX2
  else
    barStatus.Panels[3].Text := K_RCX;
end;

procedure TMainForm.SaveDesktop(aFile : string);
var
  sDesktopPath : string;
begin
  if FileExists(aFile) then
  begin
    sDesktopPath := ChangeFileExt(aFile, K_DESKTOP_EXT);
    SaveWindowValuesToFile(sDesktopPath);
    SaveDesktopMiscToFile(sDesktopPath);
  end;
end;

procedure TMainForm.LoadDesktop(aFile: string);
var
  sDesktopPath : string;
  bOldAlwaysPrompt : Boolean;
begin
  sDesktopPath := ChangeFileExt(aFile, K_DESKTOP_EXT);
  if FileExists(sDesktopPath) then
  begin
    Application.ProcessMessages;
    LoadWindowValuesFromFile(sDesktopPath);
    LoadDesktopMiscFromFile(sDesktopPath);
    // now make sure we use these values
    bOldAlwaysPrompt := FBAlwaysPrompt;
    try
      FBAlwaysPrompt := False;
      FindRCX1Click(nil);
    finally
      FBAlwaysPrompt := bOldAlwaysPrompt;
    end;
    ProgramBox.ItemIndex := CurrentProgramSlot;
  end;
end;

procedure TMainForm.cbrLeftDockDrop(Sender: TObject;
  Source: TDragDockObject; X, Y: Integer);
begin
  FixupAlignment(cbrLeft);
  FixupAlignment(pnlCodeExplorer);
  FixupAlignment(splCodeExplorer);
end;

procedure TMainForm.mniCodeExplorerClick(Sender: TObject);
begin
  ShowCodeExplorer;
end;

procedure TMainForm.ShowCodeExplorer;
begin
  frmCodeExplorer.Show;
  pnlCodeExplorer.Visible := True;
  splCodeExplorer.Visible := True;
  frmCodeExplorer.FormShow(Self);
end;

procedure TMainForm.pnlCodeExplorerDockOver(Sender: TObject;
  Source: TDragDockObject; X, Y: Integer; State: TDragState;
  var Accept: Boolean);
begin
  Accept := Source.Control is TfrmCodeExplorer;
end;

procedure TMainForm.pnlCodeExplorerGetSiteInfo(Sender: TObject;
  DockClient: TControl; var InfluenceRect: TRect; MousePos: TPoint;
  var CanDock: Boolean);
begin
  CanDock := DockClient is TfrmCodeExplorer;
end;

procedure TMainForm.mniConfigureToolsClick(Sender: TObject);
begin
  with TfrmTransferDlg.Create(nil) do
  try
    PrivateTransferList := TransferList;
    if ShowModal = mrOk then
    begin
      UpdateTransferList(PrivateTransferList);
      UpdateToolsMenu;
    end;
  finally
    Free;
  end;
end;

procedure TMainForm.UpdateTransferList(aList : TList);
var
  i : integer;
  T : TTransferItem;
begin
  for i := 0 to TransferList.Count - 1 do
  begin
    TTransferItem(TransferList[i]).Free;
  end;
  TransferList.Clear;
  for i := 0 to aList.Count - 1 do
  begin
    T := TTransferItem.Create;
    try
      TransferList.Add(T);
      T.Assign(TTransferItem(aList[i]));
    except
      T.Free;
    end
  end;
end;

procedure TMainForm.UpdateToolsMenu;
const
  K_TRANSFER_PREFIX = 'mniTransfer';
var
  i : integer;
  MI : TMenuItem;
  TI : TTransferItem;
begin
  // remove all transfer menu items first
  for i := mniTools.Count - 1 downto 0 do
  begin
    MI := mniTools.Items[i];
    if Pos(K_TRANSFER_PREFIX, MI.Name) = 1 then
    begin
      MI.Free;
    end;
  end;
  // now add new ones
  for i := 0 to TransferList.Count - 1 do
  begin
    TI := TTransferItem(TransferList[i]);
    MI := TMenuItem.Create(mniTools);
    MI.Name := K_TRANSFER_PREFIX + IntToStr(i);
    MI.OnClick := HandleTransferClick;
    MI.Caption := TI.Title;
    MI.Tag := i;
    mniTools.Add(MI);
  end;
end;

procedure TMainForm.HandleTransferClick(Sender: TObject);
var
  i : integer;
  TI : TTransferItem;
  paramStr : string;
  BadParam : Boolean;
begin
  if Sender is TMenuItem then
  begin
    i := TMenuItem(Sender).Tag;
    if (i >= 0) and (i < TransferList.Count) then
    begin
      TI := TransferList[i];
      try
        BadParam := False;
        paramStr := ProcessParams(TI.Params);
      except
        // silently eat the exception
        BadParam := True;
      end;
      if not BadParam then
        ExecuteAndContinue(PChar(TI.Path), PChar(paramStr), PChar(TI.WorkingDir), SW_SHOWNORMAL);
    end;
  end;
end;

function TMainForm.ProcessParams(aParams : string) : string;
var
  sTmp, sArg : string;
  F : TEditorForm;
  cPos, oPos, dPos : Integer;
  bFoundMacro : Boolean;
begin
  F := ActiveEditorForm;
  Result := aParams;
  if Pos(TransferMacros[9], Result) > 0 then // $SAVE
  begin
    Result := StringReplace(Result, TransferMacros[9], '', [rfReplaceAll]);
    // save current editor
    DoSave(F);
  end;
  if Pos(TransferMacros[10], Result) > 0 then // $SAVEALL
  begin
    Result := StringReplace(Result, TransferMacros[10], '', [rfReplaceAll]);
    // save all modified editors
    SaveModifiedFiles;
  end;
  if Pos(TransferMacros[0], Result) > 0 then // $COL
  begin
    sTmp := '';
    if Assigned(F) then
      sTmp := IntToStr(F.TheEditor.CaretX);
    Result := StringReplace(Result, TransferMacros[0], sTmp, [rfReplaceAll]);
  end;
  if Pos(TransferMacros[1], Result) > 0 then // $ROW
  begin
    sTmp := '';
    if Assigned(F) then
      sTmp := IntToStr(F.TheEditor.CaretY);
    Result := StringReplace(Result, TransferMacros[1], sTmp, [rfReplaceAll]);
  end;
  if Pos(TransferMacros[2], Result) > 0 then // $CURTOKEN
  begin
    sTmp := '';
    if Assigned(F) then
      sTmp := F.TheEditor.WordAtCursor;
    Result := StringReplace(Result, TransferMacros[2], sTmp, [rfReplaceAll]);
  end;
  if Pos(TransferMacros[7], Result) > 0 then // $EDNAME
  begin
    sTmp := '';
    if Assigned(F) then
      sTmp := F.FileName;
    Result := StringReplace(Result, TransferMacros[7], sTmp, [rfReplaceAll]);
  end;
  // process macros that take arguments
  repeat
    bFoundMacro := False;
    cPos := Pos(')', Result);
    if cPos > 0 then
    begin
      sTmp := Copy(Result, 1, cPos-1);
      oPos := LastDelimiter('(', sTmp);
      if oPos > 0 then
      begin
        sTmp := Copy(sTmp, 1, oPos-1);
        dPos := LastDelimiter('$', sTmp);
        if dPos > 0 then
        begin
          // check for Macro
          sTmp := Copy(sTmp, dPos, oPos-dPos) + '()';
          sArg := Copy(Result, oPos+1, cPos-oPos-1); // argument
          if sTmp = TransferMacros[3] then // $PATH()
          begin
            bFoundMacro := True;
            sTmp := ExtractFilePath(sArg);
          end
          else if sTmp = TransferMacros[4] then // $NAME()
          begin
            bFoundMacro := True;
            sTmp := ExtractFileName(sArg);
          end
          else if sTmp = TransferMacros[5] then // $NAMEONLY()
          begin
            bFoundMacro := True;
            sTmp := ChangeFileExt(ExtractFileName(sArg), '');
          end
          else if sTmp = TransferMacros[6] then // $EXT()
          begin
            bFoundMacro := True;
            sTmp := ExtractFileExt(sArg);
          end
          else if sTmp = TransferMacros[8] then // $PROMPT()
          begin
            bFoundMacro := True;
            sTmp := sArg;
            if not InputQuery(sEnterData, sEnterRunParams, sTmp) then
              Abort;
          end;
          if bFoundMacro then
            Result := Copy(Result, 1, dPos-1) + sTmp + Copy(Result, cPos+1, Length(Result));
        end;
      end;
    end;
  until not bFoundMacro;
end;

procedure TMainForm.ChangeActiveEditor;
var
  F : TEditorForm;
begin
  frmMacroManager.MacroLibrary.ActiveEditor := nil;
  F := ActiveEditorForm;
  if Assigned(F) then
    frmMacroManager.MacroLibrary.ActiveEditor := F.TheEditor;
end;

procedure TMainForm.mniMacroManagerClick(Sender: TObject);
begin
  frmMacroManager.ShowModal;
end;

procedure TMainForm.DoSaveAll;
var
  i : integer;
begin
  for i := 0 to EditorFormCount - 1 do
  begin
    DoSave(EditorForms[i]);
  end;
end;

procedure TMainForm.actFileToolbarExecute(Sender: TObject);
var
  bVis : Boolean;
begin
  actFileToolbar.Checked := not actFileToolbar.Checked;
  bVis := actFileToolbar.Checked;
  if barFile.Floating then
    barFile.HostDockSite.Visible := bVis
  else
    barFile.Visible := bVis;
end;

procedure TMainForm.actSearchToolbarExecute(Sender: TObject);
var
  bVis : Boolean;
begin
  actSearchToolbar.Checked := not actSearchToolbar.Checked;
  bVis := actSearchToolbar.Checked;
  if barSearch.Floating then
    barSearch.HostDockSite.Visible := bVis
  else
    barSearch.Visible := bVis;
end;

procedure TMainForm.actCompileToolbarExecute(Sender: TObject);
var
  bVis : Boolean;
begin
  actCompileToolbar.Checked := not actCompileToolbar.Checked;
  bVis := actCompileToolbar.Checked;
  if barCompile.Floating then
    barCompile.HostDockSite.Visible := bVis
  else
    barCompile.Visible := bVis;
end;

procedure TMainForm.actHelpToolbarExecute(Sender: TObject);
var
  bVis : Boolean;
begin
  actHelpToolbar.Checked := not actHelpToolbar.Checked;
  bVis := actHelpToolbar.Checked;
  if barHelp.Floating then
    barHelp.HostDockSite.Visible := bVis
  else
    barHelp.Visible := bVis;
end;

procedure TMainForm.actEditToolbarExecute(Sender: TObject);
var
  bVis : Boolean;
begin
  actEditToolbar.Checked := not actEditToolbar.Checked;
  bVis := actEditToolbar.Checked;
  if barEdit.Floating then
    barEdit.HostDockSite.Visible := bVis
  else
    barEdit.Visible := bVis;
end;

procedure TMainForm.actToolsToolbarExecute(Sender: TObject);
var
  bVis : Boolean;
begin
  actToolsToolbar.Checked := not actToolsToolbar.Checked;
  bVis := actToolsToolbar.Checked;
  if barTools.Floating then
    barTools.HostDockSite.Visible := bVis
  else
    barTools.Visible := bVis;
end;

procedure TMainForm.alMainUpdate(Action: TBasicAction;
  var Handled: Boolean);
begin
  if barFile.Floating then
    actFileToolbar.Checked := barFile.HostDockSite.Visible
  else
    actFileToolbar.Checked := barFile.Visible;
  if barCompile.Floating then
    actCompileToolbar.Checked := barCompile.HostDockSite.Visible
  else
    actCompileToolbar.Checked := barCompile.Visible;
  if barSearch.Floating then
    actSearchToolbar.Checked := barSearch.HostDockSite.Visible
  else
    actSearchToolbar.Checked := barSearch.Visible;
  if barHelp.Floating then
    actHelpToolbar.Checked := barHelp.HostDockSite.Visible
  else
    actHelpToolbar.Checked := barHelp.Visible;
  if barEdit.Floating then
    actEditToolbar.Checked := barEdit.HostDockSite.Visible
  else
    actEditToolbar.Checked := barEdit.Visible;
  if barTools.Floating then
    actToolsToolbar.Checked := barTools.HostDockSite.Visible
  else
    actToolsToolbar.Checked := barTools.Visible;
end;

procedure TMainForm.WMClose(var Message: TWMClose);
begin
  AppIsClosing := True;
  inherited;
end;

procedure TMainForm.mniWindowListClick(Sender: TObject);
begin
  with TfrmWindowList.Create(nil) do
  try
    ShowModal;
  finally
    Free;
  end;
end;

function TMainForm.IsStandardFirmware(aFile: string): Boolean;
begin
  Result := UpperCase(ExtractFileExt(aFile)) = '.LGO';
end;

end.

